#include <iostream>
using std::cout;
using std::cin;
using std::endl;

int main()
{
    unsigned int x = 6;
    int y = 10;

    // The integer conversion rules are complicated, and contain many pitfalls.
    // Avoid writing code that involves implicit conversion. In particular,
    // do not mix signed and unsigned types. 
    //
    // In this case, in an expression containing both signed and unsigned
    // types, the signed value is converted to unsigned, so x - y modulo (the
    // number of values an unsigned int can have) is a large number. That
    // number can be represented by a float and a long, but is too big for a
    // signed int.
    unsigned int temp = x - y;
    float a = temp;
    int b = temp; 
    long c = temp;

    cout << "temp = " << temp << '\n';
    cout << "a = " << a << '\n';
    cout << "b = " << b << '\n';
    cout << "c = " << c << '\n';

}
